bl_info = {
  "name": "Custom_SnapElement_Menu",
  "author": "SkpFX",
  "version": (0, 1),
  "blender": (2, 77, 0),
  "location": '3D View->Mesh: Add Hotkey... "wm.call_menu" Name: "Custom_SnapElement_Menu"',
  "description": "Snap Element Menu",
  "warning": "Your mileage may vary...",
  "category": "Mesh",
  "support": "TESTING"
}

import bpy

class Custom_SnapElement(bpy.types.Operator) :
  bl_label = 'snapto'
  bl_idname = 'custom.snap_element'
  
  element = bpy.props.StringProperty(name='Element')
  
  def execute(self, context):
    bpy.context.scene.tool_settings.snap_element = self.element
    return {'FINISHED'}

class Custom_SnapElement_Menu(bpy.types.Menu):
    bl_label = 'Snap Element:'
    
    def draw(self, context):
      
        layout = self.layout
        
        layout.operator_context = 'INVOKE_REGION_WIN'
        layout.operator('custom.snap_element', text='Increment', icon='SNAP_INCREMENT').element = 'INCREMENT'
        layout.operator('custom.snap_element', text='Vertex', icon='SNAP_VERTEX').element = 'VERTEX'
        layout.operator('custom.snap_element', text='Edge', icon='SNAP_EDGE').element = 'EDGE'
        layout.operator('custom.snap_element', text='Face', icon='SNAP_FACE').element = 'FACE'
        layout.operator('custom.snap_element', text='Volume', icon='SNAP_VOLUME').element = 'VOLUME'

def register():
   bpy.utils.register_class(Custom_SnapElement_Menu)
   bpy.utils.register_class(Custom_SnapElement)

def unregister():
   bpy.utils.unregister_class(Custom_SnapElement_Menu)
   bpy.utils.unregister_class(Custom_SnapElement)

